// TestMil1553UD_llib.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "windows.h"
#include "iostream"
#include "MIL1553DeviceUD.h"
//#include "unistd.h"

using namespace std;

bool testGetDMASize(){
	CMIL1553DeviceUD obj;
	UINT32 nSize;
	obj.Open(0);
	if (obj.GetDatabufSize(&nSize))
		cout<<"DMA size = "<<nSize<<"\n";
	else
		cout<<"I/O error";
	obj.Close();
return true;
}

bool testGetDmaAddress(){
  CMIL1553DeviceUD obj;
  UINT32 nAddress;
  obj.Open(0);
  if (obj.GetDatabufPhysAddr(&nAddress))
    cout<<hex<<"DMA buf address = 0x"<<nAddress<<endl;
  else
    cout<<"I/O error"<<endl;
  obj.Close();
  return true;
}

bool testGetRevision(){
	CMIL1553DeviceUD obj;
	UINT32 nSize;
	obj.Open(0);
	if (obj.GetRevision(&nSize))
		cout<<"Revision = "<<nSize<<"\n";
	else
		cout<<"I/O error";
	obj.Close();
return true;
}

bool testGetPCILoc(){
  CMIL1553DeviceUD obj;
  UINT32 nBus, nSlot;
  obj.Open(0);
  if (obj.GetPCILocation(&nBus, &nSlot))
    cout<<"Bus = "<<nBus<<" Slot = "<<nSlot<<endl;
  else
    cout<<"I/O error"<<endl;
  return true;
}


bool testWorkEnable(bool Flag){
	CMIL1553DeviceUD objEx;
	objEx.Open(0);
	if(objEx.WorkEnable(Flag))
		cout<<"Work set successfully\n";
	else
		cout<<"I/O error\n";
	objEx.Close();
  return true;
}

bool testEnableDMA(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  if (objEx.EnableDMA())
    cout<<"DMA work was enable\n";
  else
    cout<<"I/O error\n";
  return true;
}

bool testGetNBlockRawDMA(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  UINT32 nBlocks;

  if (objEx.GetNBlockRawDMA(&nBlocks))
    cout<<"Number of blocks with new data = "<<nBlocks<<"\n";
  else
    cout<<"I/O error\n";

  return true;
}

bool testReadData(){
	CMIL1553DeviceUD objEx;
	objEx.Open(0);
	UINT32 flag=0;
	UINT32 buf[32];

	for (int i=0; i<2000; i++){
		objEx.GetDMAReadyStatus(&flag);
		if (flag){
			objEx.ReadDMADataOneBlock(&buf);
			for (int i=0; i<32; i++)
				cout<<hex<<buf[i]<<"\n";
			break;
		}
	else
		cout<<"No new data\n";
	}		
	objEx.Close();
return true;
}

bool testWriteReg(UINT32 nAddr, UINT32 nData){
	CMIL1553DeviceUD objEx;
	//UINT32 nAddr = 0x2020, nData = 0xFFFFFFFF;//0x80000000;
	objEx.Open(0);
	if (objEx.WriteReg(nAddr, nData))
		cout<<hex<<"Value 0x"<<nData<<" was written to 0x"<<nAddr<<" reg\n";
	else
		cout<<"I/O error";
	objEx.Close();
return true;
}

bool testReadReg(UINT32 nAddr){
	CMIL1553DeviceUD objEx;
	UINT32 pData;//, nAddr = 0x2020;
	objEx.Open(0);
	if (objEx.ReadReg(nAddr, &pData))
		cout<<hex<<"From 0x"<<nAddr<<" reg was read value = 0x"<<pData<<"\n";
	else
		cout<<"I/O error";
	objEx.Close();
return true;
}

bool testWriteRegsValueToEEPROM(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);

  if (objEx.WriteRegsValueToEEPROM(1) == 1)
    cout<<"WriteRegsValueToEEPROM has been set"<<endl;
  else
	  cout<<"WriteRegsValueToEEPROM: I/O error"<<endl;
  //Sleep(1000);
  return true;
}

bool testReadRegsValueFromEEPROM(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);

  if (objEx.ReadRegsValueFromEEPROM(1) == 1)
    cout<<"ReadRegsValueFromEEPROM has been set"<<endl;
  else
	  cout<<"ReadRegsValueFromEEPROM: I/O error"<<endl;
  //Sleep(1000);
  return true;
}

bool testAutoLoadFromEEPROM(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);

  if (objEx.AutoLoadingAfterStartOn(1) == 1)
    cout<<"AutoLoadingAfterStartOn has been set"<<endl;
  else
	  cout<<"AutoLoadingAfterStartOn: I/O error"<<endl;
  //Sleep(1000);
  return true;
}

bool testAutoLoadFromEEPROMoff(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);

  if (objEx.AutoLoadingAfterStartOff() == 1)
    cout<<"AutoLoadingAfterStartOff has been set"<<endl;
  else
	  cout<<"AutoLoadingAfterStartOff: I/O error"<<endl;
  //Sleep(1000);
  return true;
}

bool testSetMode(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  if (objEx.SetMode(2))
    cout<<"Mode was set."<<endl;
  else
	cout<<"SetMode: I/O error."<<endl;
  return true;
}

bool testSetRTAddress(){
  CMIL1553DeviceUD objEx;
  UINT32 nAddress = 24;
  objEx.Open(0);
  if(objEx.SetRTAddress(nAddress))
    cout<<"Address "<<nAddress<<" was set."<<endl;
  else
    cout<<"SetRTAddress: I/O error."<<endl;
  objEx.Close();
  return true;
}

bool testBusSelection(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  if(objEx.BusSelection(3))
    cout<<"Buses was set."<<endl;
  else
    cout<<"BusSelection: I/O error."<<endl;
  objEx.Close();
  return true;
}


bool testEnableSubAddr(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  int nNum = 12, nRT = 0; //Enable to receive;
  if (objEx.EnableSubAddr(nRT, nNum) == 1)
    cout<<"Subaddr "<<nNum<<"was enabled."<<endl;
  else
    cout<<"EnableSubAddr: I/O error."<<endl;
  objEx.Close();
  return true;
}

bool testWriteSubAddrBuf(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  UINT32 nNum=1,
	nBufNum=1,
	nData[16],
	nSize=64;
  for (int i=0; i<16; i++)
    nData[i]=0x4321;

  if (objEx.WriteSubAddrBuf(nBufNum, nNum, nData, nSize) != 1){
    cout<<"WriteSubAddrBuf: I/O error."<<endl;
    return FALSE;
  }
  else
    cout<<"Subaddr buf was written."<<endl;
  return true;
}

bool testReadSubAddrBuf(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  UINT32 nNum=1,
	nBufNum=0,
	nData[16],
	nSize=64;
  if (objEx.ReadSubAddrBuf(nBufNum, nNum, nData, nSize) != 1){
     cout<<"ReadSubAddrBuf: I/O error."<<endl;
  return FALSE;
  }
  else{
	  cout<<"From subaddr buf was read:"<<endl;
	  for (int i=0; i<16; i++)
		  cout<<hex<<"0x"<<nData[i]<<endl;
  }
  return true;
}

bool testSetTrProgMode(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  if(objEx.SetTrProgMode(1))
    cout<<"Program mode was set to transmit."<<endl;
  else
    cout<<"SetTrProgMode: I/O error."<<endl;
  objEx.Close();
  return true;
}

bool testSetTrAutoMode(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  if(objEx.SetTrAutoMode(1))
    cout<<"Auto mode was set to transmit."<<endl;
  else
    cout<<"SetTrAutoMode: I/O error."<<endl;
  objEx.Close();
  return true;
}


bool testSetTrBufBitReady(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  if(objEx.SetTrBufBitReady(1, 3))
    cout<<"Buf 0 ready bit was set to 1."<<endl;
  else
    cout<<"SetTrBufBitReady: I/O error."<<endl;
  objEx.Close();
  return true;
}

bool testReadTrBufStatus(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  BOOL flag=false;

  if(objEx.ReadTrBufStatus(1, 0, &flag))
    cout<<"Buf ready bit was read."<<endl;
  else
    cout<<"ReadTrBufStatus: I/O error."<<endl;

  if (flag)
	  cout<<"Buffer is ready to transmit"<<endl;
  objEx.Close();
  return true;
}

bool testRegister_Interrupt(){
  CMIL1553DeviceUD objEx;
  objEx.Open(0);
  wchar_t name[17] = L"MyInterruptEvent";

  HANDLE Event= CreateEvent(NULL, TRUE, FALSE, name);
  if (!Event){
	return FALSE;
  }

  while (1){
	  if (objEx.Register_Interrupt(INT_QDAT, Event) != 1){
		  cout<<"Register_Interrupt error"<<endl;
		  return FALSE;
	  }

	  WaitForSingleObject(Event, INFINITE);
	  cout<<"Got Interrupt"<<endl;
	  ResetEvent(Event);
  }
  
  return true;
}


int _tmain(int argc, _TCHAR* argv[]){

	//testGetDMASize();
	//testGetDmaAddress();
	//testGetRevision();

	testSetMode();
	testSetRTAddress();
	testBusSelection();
	testEnableSubAddr();
	testWorkEnable(true);
	testEnableDMA();

	//testWriteSubAddrBuf();
	//testReadSubAddrBuf();

	//testSetTrProgMode();
	//testSetTrAutoMode();
	//testSetTrBufBitReady();

	//testReadTrBufStatus();

	//testGetNBlockRawDMA();
	//testReadData();

	/*testWriteReg();
	testReadReg();*/

	/*testWriteReg(0x2184, 0x400000);*/
	//testReadReg(0x2184);
	/*testReadReg(0x2000);
	testWriteReg(0x2000, 0x30000002);
	testReadReg(0x2000);
	testWriteRegsValueToEEPROM();
	testReadReg(0x2084);
	testWriteReg(0x2000, 0x0);
	testReadReg(0x2000);*/
	//testReadRegsValueFromEEPROM();
	//testReadReg(0x2000);
	//testReadReg(0x2084);*/

	/*testWriteReg(0x2000, 0x2);
	testReadReg(0x2000);
	//testAutoLoadFromEEPROM();*/
	//testAutoLoadFromEEPROMoff();
	//testReadReg(0x2000);

	//testGetPCILoc();

	testRegister_Interrupt();




	cin.get(); cin.get(); 
	return 0;
}

